diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 827166fbb..b347c3cf2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -52,14 +52,12 @@ import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.ChunkTilePos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
-import net.minecraft.core.world.save.DimensionData;
-import net.minecraft.core.world.save.LevelData;
-import net.minecraft.core.world.save.LevelStorage;
-import net.minecraft.core.world.save.PlayerIO;
+import net.minecraft.core.world.save.*;
 import net.minecraft.core.world.saveddata.SavedData;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypeGroups;
 import net.minecraft.core.world.weather.IPrecipitation;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.WeatherManager;
@@ -124,16 +122,16 @@ public class World implements MutableWorldSource {
     public boolean noNeighborUpdate = false;
     private long lockTimestamp = System.currentTimeMillis();
     public final @NotNull Random rand = new Random();
-    public boolean isNewWorld = false;
+    public final boolean isNewWorld;
     public Dimension dimension;
     public WorldType worldType;
     public IChunkProvider chunkProvider;
-    public LevelStorage saveHandler;
-    protected LevelData levelData;
-    public DimensionData dimensionData;
+    private final @NotNull LevelStorage levelStorage;
+    private final @NotNull LevelData levelData;
+    private final @NotNull DimensionData dimensionData;
     public boolean findingSpawnPoint;
     protected boolean enoughPlayersSleeping;
-    public SavedDataStorage savedDataStorage;
+    public final @NotNull SavedDataStorage savedDataStorage;
     protected final LightingEngine lightingEngine = new LightingEngineLegacy(this);
     private boolean updatingTileEntities;
 
@@ -144,110 +142,78 @@ public class World implements MutableWorldSource {
     public int dayCountLastTick;
 
     public BiomeProvider biomeProvider;
-    public AuroraProvider auroraProvider;
     public SeasonManager seasonManager;
     public WeatherManager weatherManager;
 
-    private CommandManager commandManager;
-    private final @NotNull WireHandler wireHandler;
+    private final @NotNull CommandManager commandManager = new CommandManager(isServer);
+    private final @NotNull WireHandler wireHandler = new WireHandler(this);
 
     //Usually called when a world is loaded or generated (Singleplayer & Server)
-    public World(@NotNull LevelStorage saveHandler, @NotNull String name, long seed, @Nullable Dimension dimension, @Nullable WorldType worldType, @Nullable Biome startingBiome) {
-        this.saveHandler = saveHandler;
-        this.savedDataStorage = new SavedDataStorage(saveHandler);
-        this.levelData = saveHandler.getLevelData();
-
-        this.isNewWorld = this.levelData == null;
-
-        // Attempt to determine the correct dimension for this world
-        if (dimension != null) {
-            // Provided dimension
-            this.dimension = dimension;
-        } else if (this.levelData != null) {
-            // Dimension from level data
-            this.dimension = Dimension.getDimensionList().get(this.levelData.getDimension());
-        } else {
-            // Default dimension
-            this.dimension = Dimension.getDimensionList().get(0);
-        }
+    public World(
+        final @NotNull LevelStorage levelStorage,
+        final @Nullable String name,
+        final long seed,
+        final @NotNull Dimension dimension,
+        final @Nullable Biome startingBiome
+    ) {
+        this.levelStorage = levelStorage;
+        this.savedDataStorage = new SavedDataStorage(levelStorage);
 
-        this.dimensionData = saveHandler.getDimensionData(this.dimension.id);
+        final @Nullable LevelData levelData = levelStorage.getLevelData();
+        this.isNewWorld = levelData == null;
+        this.levelData = Objects.requireNonNullElseGet(levelData, () -> new LevelData(seed, name));
 
-        // Attempt to determine the correct world type for this world
-        if (worldType != null) {
-            // Provided world type
-            this.worldType = worldType;
-        } else if (this.dimensionData != null) {
-            // World type from dimension data
-            this.worldType = this.dimensionData.getWorldType();
-        } else {
-            // Default world type
-            this.worldType = this.dimension.defaultWorldType;
-        }
+        // Provided dimension
+        this.dimension = dimension;
+        this.dimensionData = Objects.requireNonNullElseGet(levelStorage.getDimensionData(this.dimension.id), () -> new DimensionData(this.dimension.defaultWorldType));
 
-        boolean isNewWorld = false;
-        if (this.levelData == null) {
-            this.levelData = new LevelData(seed, name);
-            isNewWorld = true;
-        }
+        // World type from dimension data
+        this.worldType = this.dimensionData.getWorldType();
 
-        if (this.dimensionData == null) {
-            this.dimensionData = new DimensionData(this.worldType);
-            this.weatherManager = new WeatherManager(this);
-        } else {
-            this.weatherManager = new WeatherManager(this,
-                this.dimensionData.getCurrentWeather(),
-                this.dimensionData.getNextWeather(),
-                this.dimensionData.getWeatherDuration(),
-                this.dimensionData.getWeatherPower()
-            );
-        }
+        this.weatherManager = new WeatherManager(this,
+            this.dimensionData.getCurrentWeather(),
+            this.dimensionData.getNextWeather(),
+            this.dimensionData.getWeatherDuration(),
+            this.dimensionData.getWeatherPower()
+        );
 
         this.chunkProvider = createChunkProvider();
 
-        this.auroraProvider = new AuroraProvider(this, this.levelData.getRandomSeed());
-
         this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
 
         this.biomeProvider = this.worldType.createBiomeProvider(this);
 
-        if (isNewWorld) {
+        if (this.isNewWorld) {
             this.worldType.onWorldCreation(this);
             getInitialSpawnLocation(startingBiome);
         }
         updateSkyBrightness();
 
-        this.commandManager = new CommandManager(isServer);
         this.commandManager.init();
-
-        this.wireHandler = new WireHandler(this);
     }
 
     //Usually called when going through portals
-    public World(World world, Dimension dimension) {
-        this.lockTimestamp = world.lockTimestamp;
-        this.saveHandler = world.saveHandler;
+    public World(final @NotNull World parent, final @NotNull Dimension dimension) {
+        this.lockTimestamp = parent.lockTimestamp;
+        this.levelStorage = parent.levelStorage;
+        this.dimension = dimension;
 
-        this.levelData = new LevelData(world.levelData);
+        this.levelData = new LevelData(parent.levelData);
+        this.dimensionData = Objects.requireNonNullElseGet(parent.levelStorage.getDimensionData(this.dimension.id), () -> new DimensionData(this.dimension.defaultWorldType));
 
-        this.dimensionData = world.saveHandler.getDimensionData(dimension.id);
-        if (this.dimensionData == null) {
-            this.dimensionData = new DimensionData(dimension.defaultWorldType);
-            this.weatherManager = new WeatherManager(this);
-        } else {
-            this.weatherManager = new WeatherManager(this,
-                this.dimensionData.getCurrentWeather(),
-                this.dimensionData.getNextWeather(),
-                this.dimensionData.getWeatherDuration(),
-                this.dimensionData.getWeatherPower()
-            );
-        }
+        this.weatherManager = new WeatherManager(this,
+            this.dimensionData.getCurrentWeather(),
+            this.dimensionData.getNextWeather(),
+            this.dimensionData.getWeatherDuration(),
+            this.dimensionData.getWeatherPower()
+        );
+
+        this.isNewWorld = false;
 
         // Set up info from dimension data
         this.worldType = this.dimensionData.getWorldType();
 
-        this.savedDataStorage = new SavedDataStorage(this.saveHandler);
-        this.dimension = dimension;
+        this.savedDataStorage = new SavedDataStorage(this.levelStorage);
         this.chunkProvider = createChunkProvider();
         this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
 
@@ -255,40 +221,50 @@ public class World implements MutableWorldSource {
 
         updateSkyBrightness();
 
-        this.auroraProvider = new AuroraProvider(this, this.getRandomSeed());
-
-        this.commandManager = new CommandManager(isServer);
         this.commandManager.init();
-
-        this.wireHandler = new WireHandler(this);
     }
 
     //Usually called when joining a server
-    public World(LevelStorage saveHandler, String name, Dimension dimension, WorldType worldType, long seed) {
-        this.saveHandler = saveHandler;
+    public World(
+        final @NotNull SavedDataStorage savedDataStorage,
+        final @NotNull String name,
+        final long seed,
+        final @NotNull Dimension dimension,
+        final @NotNull WorldType worldType
+    ) {
+        this.levelStorage = savedDataStorage.getLevelStorage();
+        this.savedDataStorage = savedDataStorage;
+
         this.levelData = new LevelData(seed, name);
+        this.isNewWorld = false;
+
+        // Provided dimension
         this.dimension = dimension;
         this.dimensionData = new DimensionData(worldType);
+
+        // Provided world type
         this.worldType = worldType;
-        this.savedDataStorage = new SavedDataStorage(saveHandler);
-        this.chunkProvider = createChunkProvider();
-        this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
-        updateSkyBrightness();
 
         this.weatherManager = new WeatherManager(this);
 
-        this.auroraProvider = new AuroraProvider(this, this.levelData.getRandomSeed());
+        this.chunkProvider = createChunkProvider();
+
+        this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
 
         this.biomeProvider = this.worldType.createBiomeProvider(this);
 
-        this.commandManager = new CommandManager(isServer);
-        this.commandManager.init();
+        this.updateSkyBrightness();
 
-        this.wireHandler = new WireHandler(this);
+        this.commandManager.init();
     }
 
     public World() {
-        this.wireHandler = new WireHandler(this);
+        this.levelStorage = new LevelStorageDummy();
+        this.savedDataStorage = new SavedDataStorage(this.levelStorage);
+
+        this.isNewWorld = false;
+        this.levelData = new LevelData(0, "Dummy World");
+        this.dimensionData = new DimensionData(WorldTypeGroups.DEFAULT.get(Dimension.OVERWORLD));
     }
 
     public <T> T getGameRuleValue(GameRule<T> gameRule) {
@@ -317,7 +293,7 @@ public class World implements MutableWorldSource {
     }
 
     protected IChunkProvider createChunkProvider() {
-        IChunkLoader chunkLoader = this.saveHandler.getChunkLoader(this.dimension);
+        IChunkLoader chunkLoader = this.levelStorage.getChunkLoader(this.dimension);
         return accessor.createChunkProvider(this, chunkLoader);
     }
 
@@ -342,7 +318,7 @@ public class World implements MutableWorldSource {
     public void spawnPlayerWithLoadedChunks(Player player, boolean respawning) {
         try {
             if (!respawning) {
-                PlayerIO playerIO = this.saveHandler.getPlayerFileData();
+                PlayerIO playerIO = this.levelStorage.getPlayerFileData();
                 if (playerIO != null) {
                     playerIO.load(player);
                 }
@@ -381,8 +357,8 @@ public class World implements MutableWorldSource {
 
     private void saveWorldData() {
         checkSessionLock();
-        this.saveHandler.saveLevelDataAndPlayerData(this.levelData, this.players);
-        this.saveHandler.saveDimensionData(this.dimension.id, this.dimensionData);
+        this.levelStorage.saveLevelDataAndPlayerData(this.levelData, this.players);
+        this.levelStorage.saveDimensionData(this.dimension.id, this.dimensionData);
         this.savedDataStorage.save();
     }
 
@@ -2578,7 +2554,7 @@ public class World implements MutableWorldSource {
     }
 
     public void checkSessionLock() {
-        this.saveHandler.checkSessionLock();
+        this.levelStorage.checkSessionLock();
     }
 
     public void setWorldTime(long l) {
@@ -2713,14 +2689,18 @@ public class World implements MutableWorldSource {
         this.triggerEvent(new TilePos(x, y, z), index, data);
     }
 
-    public LevelStorage getSaveHandler() {
-        return this.saveHandler;
+    public @NotNull LevelStorage getLevelStorage() {
+        return this.levelStorage;
     }
 
-    public LevelData getLevelData() {
+    public @NotNull LevelData getLevelData() {
         return this.levelData;
     }
 
+    public @NotNull DimensionData getDimensionData() {
+        return this.dimensionData;
+    }
+
     public void updateEnoughPlayersSleepingFlag(Player player) {
         this.enoughPlayersSleeping = false;
         if (!this.players.isEmpty()) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java b/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
index 9f2cd1e1d..76d24531b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
@@ -10,15 +10,17 @@ import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.io.File;
 import java.io.IOException;
 import java.nio.file.Files;
+import java.util.Objects;
 
 public class DimensionData
 {
-    private String worldType;
+    private @NotNull String worldType;
     private int weatherCurrentId = -1;
     private int weatherNextId = -1;
     private long weatherDuration;
@@ -127,9 +129,9 @@ public class DimensionData
         weatherPower = weatherTag.getFloat("Power");
     }
 
-    public WorldType getWorldType()
+    public @NotNull WorldType getWorldType()
     {
-        return Registries.WORLD_TYPES.getItem(worldType);
+        return Objects.requireNonNull(Registries.WORLD_TYPES.getItem(this.worldType));
     }
 
     public void setWorldType(WorldType type)
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java b/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java
index 1aba0dcde..1ef4e0acc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/ISaveFormat.java
@@ -29,7 +29,7 @@ public interface ISaveFormat
      * @param isMultiplayer Whether the world is being loaded for use on a multiplayer server.
      * @return The created save handler.
      */
-    LevelStorage getSaveHandler(String worldDirName, boolean isMultiplayer);
+    LevelStorage getLevelStorage(String worldDirName, boolean isMultiplayer);
 
     /**
      * Fetches a list containing the save files present in the user's save directory.
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java
similarity index 97%
rename from game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
rename to game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java
index e33df5c6a..c0153e7ce 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java
@@ -21,7 +21,7 @@ import java.nio.file.Files;
 import java.util.List;
 import java.util.UUID;
 
-public abstract class SaveHandlerBase implements LevelStorage
+public abstract class LevelStorageBase implements LevelStorage
 {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	protected final String worldDirName;
@@ -31,7 +31,7 @@ public abstract class SaveHandlerBase implements LevelStorage
 	protected final long now = System.currentTimeMillis();
 	protected final ISaveFormat saveFormat;
 
-	public SaveHandlerBase(ISaveFormat saveFormat, File savesDir, String worldDirName)
+	public LevelStorageBase(ISaveFormat saveFormat, File savesDir, String worldDirName)
 	{
 		this.worldDirName = worldDirName;
 		this.saveFormat = saveFormat;
@@ -319,6 +319,6 @@ public abstract class SaveHandlerBase implements LevelStorage
 
 	@FunctionalInterface
 	public static interface SaveHandlerFactory {
-		@NotNull SaveHandlerBase apply(ISaveFormat saveFormat, File savesDir, String worldDirName);
+		@NotNull LevelStorageBase apply(ISaveFormat saveFormat, File savesDir, String worldDirName);
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerCore.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageCore.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerCore.java
rename to game/core/src/main/java/net/minecraft/core/world/save/LevelStorageCore.java
index bb4f31318..ea71bcfee 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerCore.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageCore.java
@@ -9,11 +9,11 @@ import org.jetbrains.annotations.NotNull;
 import java.io.File;
 import java.util.List;
 
-public class SaveHandlerCore
-        extends SaveHandlerBase
+public class LevelStorageCore
+        extends LevelStorageBase
 {
 
-    public SaveHandlerCore(ISaveFormat saveFormat, File savesDir, String worldDirName)
+    public LevelStorageCore(ISaveFormat saveFormat, File savesDir, String worldDirName)
     {
         super(saveFormat, savesDir, worldDirName);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageDummy.java
similarity index 93%
rename from game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
rename to game/core/src/main/java/net/minecraft/core/world/save/LevelStorageDummy.java
index b34d11805..0f667e959 100644
--- a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageDummy.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.world.save;
+package net.minecraft.core.world.save;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.player.Player;
@@ -15,10 +15,9 @@ import java.io.File;
 import java.util.List;
 import java.util.UUID;
 
-public class SaveHandlerClientMP
-		implements LevelStorage
+public class LevelStorageDummy implements LevelStorage
 {
-	public SaveHandlerClientMP()
+	public LevelStorageDummy()
 	{
 		
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageServer.java
similarity index 88%
rename from game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
rename to game/core/src/main/java/net/minecraft/core/world/save/LevelStorageServer.java
index eb2f09484..c57d949e8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageServer.java
@@ -14,13 +14,13 @@ import java.io.File;
 import java.util.List;
 
 
-public class SaveHandlerServer
-        extends SaveHandlerBase
+public class LevelStorageServer
+        extends LevelStorageBase
         implements PlayerIO
 {
     private static final Logger LOGGER = LogUtils.getLogger();
 
-    public SaveHandlerServer(ISaveFormat saveFormat, File savesDir, String worldDirName, boolean isMultiplayer)
+    public LevelStorageServer(ISaveFormat saveFormat, File savesDir, String worldDirName, boolean isMultiplayer)
     {
         super(saveFormat, savesDir, worldDirName);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
index d479aba76..f6915c744 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
@@ -22,7 +22,7 @@ public abstract class SaveFormatBase
     private static final Logger LOGGER = LogUtils.getLogger();
     protected final File savesDir;
 
-    public @NotNull SaveHandlerBase.SaveHandlerFactory factory = SaveHandlerCore::new;
+    public @NotNull LevelStorageBase.SaveHandlerFactory factory = LevelStorageCore::new;
 
     public SaveFormatBase(File savesDir)
     {
@@ -218,7 +218,7 @@ public abstract class SaveFormatBase
     }
 
     @Override
-    public LevelStorage getSaveHandler(String worldDirName, boolean isMultiplayer)
+    public LevelStorage getLevelStorage(String worldDirName, boolean isMultiplayer)
     {
         return factory.apply(this, savesDir, worldDirName);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
index 89ca0dda9..516e62308 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
@@ -77,7 +77,7 @@ public class SaveConverter19133To19134
                 {
                     dimensionData = new DimensionData(dim.defaultWorldType);
                 }
-                toFormat.getSaveHandler(worldDirName, false).saveDimensionData(dim.id, dimensionData);
+                toFormat.getLevelStorage(worldDirName, false).saveDimensionData(dim.id, dimensionData);
             }
         }
         else return;
diff --git a/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java b/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
index f2bb30c14..768844743 100644
--- a/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
+++ b/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
@@ -8,6 +8,7 @@ import com.mojang.nbt.NbtIo;
 import it.unimi.dsi.fastutil.objects.Object2ShortMap;
 import it.unimi.dsi.fastutil.objects.Object2ShortOpenHashMap;
 import net.minecraft.core.world.save.LevelStorage;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.io.*;
@@ -17,12 +18,12 @@ import java.util.*;
 public class SavedDataStorage
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private final LevelStorage storage;
+    private final @NotNull LevelStorage storage;
     private final Map<Serializable, SavedData> cache;
     private final List<SavedData> loadedData;
     private final Object2ShortMap<String> idCounts;
 
-    public SavedDataStorage(LevelStorage storage)
+    public SavedDataStorage(final @NotNull LevelStorage storage)
     {
         cache = new HashMap<>();
         loadedData = new ArrayList<>();
@@ -31,6 +32,10 @@ public class SavedDataStorage
         loadMetadata();
     }
 
+    public @NotNull LevelStorage getLevelStorage() {
+        return this.storage;
+    }
+
     public SavedData load(Class<? extends SavedData> savedDataClass, String id)
     {
         SavedData savedData = cache.get(id);
@@ -38,31 +43,21 @@ public class SavedDataStorage
         {
             return savedData;
         }
-        if(storage != null)
-        {
-            try
-            {
-                File file = storage.getDataFile(id);
-                if(file != null && file.exists())
-                {
-                    try
-                    {
-                        savedData = savedDataClass.getConstructor(String.class).newInstance(id);
-                    }
-                    catch(Exception exception1)
-                    {
-                        throw new RuntimeException("Failed to instantiate " + savedDataClass.toString(), exception1);
-                    }
-                    InputStream fis = Files.newInputStream(file.toPath());
-                    CompoundTag tag = NbtIo.readCompressed(fis);
-                    fis.close();
-                    savedData.load(tag.getCompound("data"));
+        try {
+            File file = storage.getDataFile(id);
+            if (file != null && file.exists()) {
+                try {
+                    savedData = savedDataClass.getConstructor(String.class).newInstance(id);
+                } catch (Exception exception1) {
+                    throw new RuntimeException("Failed to instantiate " + savedDataClass.toString(), exception1);
                 }
+                InputStream fis = Files.newInputStream(file.toPath());
+                CompoundTag tag = NbtIo.readCompressed(fis);
+                fis.close();
+                savedData.load(tag.getCompound("data"));
             }
-            catch(Exception e)
-            {
-                LOGGER.error("Exception loading saved data for id '{}'!", id, e);
-            }
+        } catch (Exception e) {
+            LOGGER.error("Exception loading saved data for id '{}'!", id, e);
         }
         if(savedData != null)
         {
@@ -101,10 +96,6 @@ public class SavedDataStorage
 
     private void save(SavedData savedData)
     {
-        if(storage == null)
-        {
-            return;
-        }
         try
         {
             File file = storage.getDataFile(savedData.id);
@@ -130,10 +121,6 @@ public class SavedDataStorage
         try
         {
             idCounts.clear();
-            if(storage == null)
-            {
-                return;
-            }
             File file = storage.getDataFile("idcounts");
             if(file != null && file.exists())
             {
@@ -160,10 +147,6 @@ public class SavedDataStorage
     {
         short metadata = (short) (idCounts.getOrDefault(type, (short) -1) + 1);
         idCounts.put(type, metadata);
-        if(storage == null)
-        {
-            return metadata;
-        }
         try
         {
             File file = storage.getDataFile("idcounts");
diff --git a/game/core/src/main/java/net/minecraft/core/world/season/Season.java b/game/core/src/main/java/net/minecraft/core/world/season/Season.java
index c6401a185..c7cbfc2ba 100644
--- a/game/core/src/main/java/net/minecraft/core/world/season/Season.java
+++ b/game/core/src/main/java/net/minecraft/core/world/season/Season.java
@@ -2,13 +2,14 @@ package net.minecraft.core.world.season;
 
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.weather.Weather;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.*;
 
 public abstract class Season
 {
-	private final String id;
-	private final String languageKey;
+	private final @NotNull String id;
+	private final @NotNull String languageKey;
 
 	public List<Weather> allowedWeathers = new ArrayList<>();
 	public Map<Weather, Float> weatherProbability = new HashMap<>();
@@ -23,13 +24,13 @@ public abstract class Season
 	public float saplingDropFactor = 1.0f;
 	public float mobSpawnRateModifier = 1.0f;
 	
-	public Season(String id)
+	public Season(final @NotNull String id)
 	{
 		this.id = id;
 		this.languageKey = "season." + id;
 	}
 	
-	public Season(String id, boolean hasFallingLeaves, boolean hasDeeperSnow)
+	public Season(final @NotNull String id, boolean hasFallingLeaves, boolean hasDeeperSnow)
 	{
 		this(id);
 		this.hasFallingLeaves = hasFallingLeaves;
@@ -41,7 +42,11 @@ public abstract class Season
 		return id;
 	}
 
-	public String getTranslatedName()
+	public @NotNull String getLanguageKey() {
+		return this.languageKey;
+	}
+
+	public @NotNull String getTranslatedName()
 	{
 		return I18n.getInstance().translateKey(languageKey + ".name");
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ContainerSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/ContainerSettingNode.java
new file mode 100644
index 000000000..7f84c0905
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ContainerSettingNode.java
@@ -0,0 +1,33 @@
+package net.minecraft.core.world.settings;
+
+import org.jetbrains.annotations.NotNull;
+
+public class ContainerSettingNode implements SettingNode {
+    private final @NotNull SettingNodeChildrenProvider childrenProvider;
+    private @NotNull SettingNodeVisibilityListener visibilityListener = SettingNodeVisibilityListener::alwaysVisible;
+
+    public ContainerSettingNode(final @NotNull SettingNodeChildrenProvider childrenProvider) {
+        this.childrenProvider = childrenProvider;
+    }
+
+    public final @NotNull ContainerSettingNode withVisibilityListener(final @NotNull SettingNodeVisibilityListener visibilityListener) {
+        this.visibilityListener = visibilityListener;
+
+        return this;
+    }
+
+    @Override
+    public @NotNull SettingNodeChildrenProvider getChildrenProvider() {
+        return this.childrenProvider;
+    }
+
+    @Override
+    public boolean isVisible(final @NotNull WorldConfiguration worldConfiguration) {
+        return this.visibilityListener.isVisible(worldConfiguration);
+    }
+
+    @Override
+    public boolean areChildrenVisible(final @NotNull WorldConfiguration worldConfiguration) {
+        return this.visibilityListener.isVisible(worldConfiguration);
+    }
+}
